/*
 * io.h
 *
 *  Created on: 07.04.2013
 *      Author: rj
 */

#ifndef IO_H_
#define IO_H_

#include "inc/hw_adc.h"
#include "inc/hw_gpio.h"
#include "inc/hw_memmap.h"
#include "inc/hw_timer.h"

#define SAMPLE_RATE 31250
#define HW_AVERAGING 2
#define SW_AVERAGING 16
#define ADC_CENTER_VAL 2048
#define PWM_CENTER_DUTY halfSamplePeriod
#define SYSTICKS_PER_SEC SAMPLE_RATE
#define ZERO_ADJUST_AVERAGES SAMPLE_RATE/2
#define AUX_TIMER_DEFAULT_FREQ 1.e5

#define PWM_TIMER_PERIPH SYSCTL_PERIPH_TIMER2
#define PWM_TIMER_BASE TIMER2_BASE
#define PWM_TIMER_A_INT_TRIGGER TIMER_CAPA_EVENT
#define PWM_TIMER_B_INT_TRIGGER TIMER_CAPB_EVENT
#define PWM_TIMER_INT_TRIGGER (PWM_TIMER_A_INT_TRIGGER|PWM_TIMER_B_INT_TRIGGER)
#define PWM_TIMER_A_SYNC TIMER_2A_SYNC
#define PWM_TIMER_B_SYNC TIMER_2B_SYNC
#define PWM_TIMER_A_PIN_PERIPH SYSCTL_PERIPH_GPIOB
#define PWM_TIMER_B_PIN_PERIPH SYSCTL_PERIPH_GPIOB
#define PWM_TIMER_A_PIN_CFG GPIO_PB0_T2CCP0
#define PWM_TIMER_B_PIN_CFG GPIO_PB1_T2CCP1
#define PWM_TIMER_A_PIN_BASE GPIO_PORTB_BASE
#define PWM_TIMER_B_PIN_BASE GPIO_PORTB_BASE
#define PWM_TIMER_A_PIN GPIO_PIN_0
#define PWM_TIMER_B_PIN GPIO_PIN_1

#define ADC_TIMER_PERIPH SYSCTL_PERIPH_TIMER3
#define ADC_TIMER_BASE TIMER3_BASE
#define REF_TIMER_BASE TIMER3_BASE
#define ADC_TIMER TIMER_A
#define REF_TIMER TIMER_B
#define REF_TIMER_PIN_PERIPH SYSCTL_PERIPH_GPIOB
#define REF_TIMER_PIN_CFG GPIO_PB3_T3CCP1
#define REF_TIMER_PIN_BASE GPIO_PORTB_BASE
#define REF_TIMER_PIN GPIO_PIN_3
#define ADC_TIMER_INT_TRIGGER TIMER_TIMA_TIMEOUT
#define ADC_TIMER_SYNC TIMER_3A_SYNC
#define REF_TIMER_SYNC TIMER_3B_SYNC

#define AUX_TIMER_PERIPH SYSCTL_PERIPH_TIMER1
#define AUX_TIMER_BASE TIMER1_BASE
#define AUX_TIMER_A TIMER_A
#define AUX_TIMER_B TIMER_B
#define AUX_TIMER_A_PIN_PERIPH SYSCTL_PERIPH_GPIOB
#define AUX_TIMER_B_PIN_PERIPH SYSCTL_PERIPH_GPIOB
#define AUX_TIMER_A_PIN_CFG GPIO_PB4_T1CCP0
#define AUX_TIMER_B_PIN_CFG GPIO_PB5_T1CCP1
#define AUX_TIMER_A_PIN_BASE GPIO_PORTB_BASE
#define AUX_TIMER_B_PIN_BASE GPIO_PORTB_BASE
#define AUX_TIMER_A_PIN GPIO_PIN_4
#define AUX_TIMER_B_PIN GPIO_PIN_5
#define AUX_TIMER_A_SYNC TIMER_1A_SYNC
#define AUX_TIMER_B_SYNC TIMER_1B_SYNC

#define ADC0_CH ADC_CTL_CH1
#define ADC1_CH ADC_CTL_CH0
#define ADC0_PIN_PERIPH SYSCTL_PERIPH2_GPIOE
#define ADC1_PIN_PERIPH SYSCTL_PERIPH2_GPIOE
#define ADC0_PIN_CFG 0
#define ADC1_PIN_CFG 0
#define ADC0_PIN_BASE GPIO_PORTE_BASE
#define ADC1_PIN_BASE GPIO_PORTE_BASE
#define ADC0_PIN GPIO_PIN_2
#define ADC1_PIN GPIO_PIN_3

void initPWM();
void initAUXTimer();
long resetPWM();
void resetAUXTimer();
void updateAUXTimerValue(void *var, void *newVal);
void initADC();
long resetADC();
long reviveADC(void);
long syncIO();
long ioOffsetInClocks();
long ioOffset();
long outputSkewInClocks();
long outputSkew();
long sysTickOffsetInClocks();
long sysTickOffset();
long zeroAdjustInputA();
long zeroAdjustInputB();

void getAdcValues(float *xA,float *xB);
void setPWMDuties(float xA,float xB);

#ifdef EXT_PROFILE
#define GPIO_ENABLE_PIN(GPIO_BASE,GPIO_PIN) \
		HWREG(GPIO_BASE +(GPIO_O_DATA + (GPIO_PIN << 2))) |= GPIO_PIN
#define GPIO_DISABLE_PIN(GPIO_BASE,GPIO_PIN) \
		HWREG(GPIO_BASE +(GPIO_O_DATA + (GPIO_PIN << 2))) &= ~(GPIO_PIN)
#define EXT_PROFILE_MAIN_GPIO_PERIPH SYSCTL_PERIPH_GPIOF
#define EXT_PROFILE_MAIN_GPIO_BASE GPIO_PORTF_BASE
#define EXT_PROFILE_MAIN_GPIO_PIN GPIO_PIN_1
#define EXT_PROFILE_ADC_GPIO_PERIPH SYSCTL_PERIPH_GPIOF
#define EXT_PROFILE_ADC_GPIO_BASE GPIO_PORTF_BASE
#define EXT_PROFILE_ADC_GPIO_PIN GPIO_PIN_3

void initExternalProfiling();
#endif

#endif /* IO_H_ */
